function Kn=KnDC(X_DC,sigma_Xn,n)

%  Finds the best fit gain Kn for a quantizer.
% (corresponds to eq. (9))
%
%  X_DC       : the dc level at the quantizer input
%  sigma_Xn   : the noise rms value at  the quantizer input
%  n   : the number of unit elements 
%        must be even in the current version
%
% (C) Pieter Rombouts

% Handle the input arguments
% Code Fragment inspired on code from
% Richard Schreier's delta sigma Toolbox
parameters = {'X_DC' 'sigma_Xn' 'n'};
defaults = {0.5 0.1 8};
for arg_i=2:length(defaults)
    parameter = char(parameters(arg_i));
    if arg_i>nargin | ( eval(['isnumeric(' parameter ') '])  &  ...
     eval(['any(isnan(' parameter ')) | isempty(' parameter ') ']) )
        eval([parameter '=defaults{arg_i};'])
    end
end
% End of handling of the input arguments



delta = 2/n;
i=1:n;
exp_arguments = -((1+delta/2+X_DC-i*delta)/(sqrt(2)*sigma_Xn)).^2;
contributions = delta/sqrt(2*pi)/sigma_Xn*exp(exp_arguments);
Kn = sum(contributions);
