function Kn=KnSin(a,sigma,n)

%  Finds the best fit gain Kn for a quantizer.
% (corresponds to eq. (16))
%
%  a       : the amplitude at the quantizer input
%  sigma   : the noise rms value at  the quantizer input
%  n   : the number of unit elements 
%        must be even in the current version
%
% (C) Pieter Rombouts

% Handle the input arguments
% Code Fragment inspired on code from
% Richard Schreier's delta sigma Toolbox
parameters = {'a' 'sigma' 'n'};
defaults = {0.5 0.1 8};
for arg_i=2:length(defaults)
    parameter = char(parameters(arg_i));
    if arg_i>nargin | ( eval(['isnumeric(' parameter ') '])  &  ...
     eval(['any(isnan(' parameter ')) | isempty(' parameter ') ']) )
        eval([parameter '=defaults{arg_i};'])
    end
end
% End of handling of the input arguments


step = 0.01;
thetarange = (-1:step:1)*pi/2;
    

length(thetarange);

Kn = 0;

if (a==0), 
  Kn = KnSin(1e-4,sigma,n);
else
  delta = 2/n;
  for i=1:n;
      B = 1+delta/2-i*delta;
      %integs_args = exp(-(1/2)*(-a*sin(thetarange)+B).^2/sigma^2);
      integs_args = exp(-(1/2)*(+a*sin(thetarange)+B).^2/sigma^2);
      integ = trapz(thetarange,integs_args);
      Kn = Kn + integ;
  end % for i
  Kn = Kn*delta/sigma/pi^(3/2)/sqrt(2);
end % if

