function Ks=KsDC(X_DC,sigma_Xn,n)

%  Finds the best fit gain Ks for a quantizer.
% (corresponds to eq. (10))
%
%  X_DC       : the dc level at the quantizer input
%  sigma_Xn   : the noise rms value at  the quantizer input
%  n   : the number of unit elements 
%        must be even in the current version
%
% (C) Pieter Rombouts

% Handle the input arguments
% Code Fragment inspired on code from
% Richard Schreier's delta sigma Toolbox
parameters = {'X_DC' 'sigma_Xn' 'n'};
defaults = {0.5 0.1 8};
for arg_i=2:length(defaults)
    parameter = char(parameters(arg_i));
    if arg_i>nargin | ( eval(['isnumeric(' parameter ') '])  &  ...
     eval(['any(isnan(' parameter ')) | isempty(' parameter ') ']) )
        eval([parameter '=defaults{arg_i};'])
    end
end
% End of handling of the input arguments



if (X_DC==0), 
  Ks = (KsDC(1e-4,sigma_Xn,n) + KsDC(-1e-4,sigma_Xn,n))/2;
else
  delta = 2/n;
  i=1:n;
  erf_arguments = (1+delta/2+X_DC-i*delta)/(sqrt(2)*sigma_Xn);
  contributions = delta/2/X_DC*erf(erf_arguments);
  Ks = sum(contributions);
end % if

