function Ks=KsSin(a,sigma,n)

%  Finds the best fit gain Ks for a quantizer.
% (corresponds to eq. (18))
%
%  a       : the amplitude at the quantizer input
%  sigma   : the noise rms value at  the quantizer input
%  n   : the number of unit elements 
%        must be even in the current version
%
% (C) Pieter Rombouts

% Handle the input arguments
% Code Fragment inspired on code from
% Richard Schreier's delta sigma Toolbox
parameters = {'a' 'sigma' 'n'};
defaults = {0.5 0.1 8};
for arg_i=2:length(defaults)
    parameter = char(parameters(arg_i));
    if arg_i>nargin | ( eval(['isnumeric(' parameter ') '])  &  ...
     eval(['any(isnan(' parameter ')) | isempty(' parameter ') ']) )
        eval([parameter '=defaults{arg_i};'])
    end
end
% End of handling of the input arguments

step = 0.01;
thetarange = (-1:step:1)*pi/2;
    

length(thetarange);

Ks = 0;

if (a==0), 
  Ks = KsSin(1e-4,sigma,n);
else
  delta = 2/n;
  for i=1:n;
      B = 1+delta/2-i*delta;
      integs_args = 1/2/pi*sin(thetarange).*(erf((1/sqrt(2))*(a*sin(thetarange)+B)/sigma)+1);
      integ = trapz(thetarange,integs_args);
      Ks = Ks + integ;
  end % for i
  Ks = Ks*delta*2/a;
end % if

