function Sin_OL =findSin_OL_DF(ntf,n, mode)

%  Finds the prediction of the sinusoidal overloading level with describing
%  function analysis
%
%  ntf : the noise transfer function
%  n   : the number of unit elements 
%        must be even in the current version
%  mode = 0;  assume that the quantisation noise is white (default)
%         1;  assume that the quantisation noise has a worst-case spectrum
%
% (C) Pieter Rombouts
      
      

% Handle the input arguments
% Code Fragment inspired on code from
% Richard Schreier's delta sigma Toolbox
parameters = {'ntf' 'n' 'mode'};
defaults = {[] 8 0};
for arg_i=2:length(defaults)
    parameter = char(parameters(arg_i));
    if arg_i>nargin | ( eval(['isnumeric(' parameter ') '])  &  ...
     eval(['any(isnan(' parameter ')) | isempty(' parameter ') ']) )
        eval([parameter '=defaults{arg_i};'])
    end
end
% End of handling of the input arguments

accuracy = 0.001;

Sin_low = max(0.01, findOL_Carley(ntf,n));
Sin_high = 1+2/n;
stopcriterium = 0;
while ~stopcriterium
  Sin_candidate = 0.5*(Sin_low + Sin_high);
  [Kn,Ks,sigma_sat,converge,stabiel,S_XN] = findDescFunctSin(ntf,Sin_candidate,n,1,1,mode);
  if stabiel, Sin_low = Sin_candidate; else Sin_high= Sin_candidate; end %if
  if (Sin_high-Sin_low)<accuracy, stopcriterium = 1; end %if
end % for
Sin_OL = Sin_low;